function AaoMfdLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastAaoSend = '';
	var dloop;
	var lastString = "";
	var isLvarsActive = false;

	function DataLoop () {
		let apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let mfdIndex = 0;
			let hpmfd = document.getElementsByTagName("hx2-instrument");
			if (hpmfd && hpmfd.length > 0){
				let lurl = hpmfd[0].getAttribute("url");
				let iIdx = lurl.toLowerCase().indexOf("index=");
				if (iIdx < 0){
					clearInterval(this.dloop);
					return;
				}
				mfdIndex = parseInt(lurl.substr(iIdx + 6, 1));
			}
			let requestObj = {};
			requestObj.setstringvars = [];
			requestObj.setvars = [];
			// read softkey labels
			let currStr = "";
			let mfr = document.getElementById("Mainframe");
			if (mfr){
				let activePage = mfr.getAttribute("page");
				let pages = document.getElementsByClassName("mfd-page");
				for (let p = 0; p < pages.length; p++){
					let pgEl = pages[p];
					let pgNam = pgEl.getAttribute("page");
					if (pgNam === activePage){
						let skeys = document.getElementsByClassName("softkey_top");
						if (skeys){
							currStr += WriteButtons(skeys, "T", requestObj, mfdIndex);
						}
                        
						skeys = pgEl.getElementsByClassName("softkey_top");
						if (skeys){
							currStr += WriteButtons(skeys, "T", requestObj, mfdIndex);
						}
						skeys = pgEl.getElementsByClassName("softkey_left");
						if (skeys){
							currStr += WriteButtons(skeys, "L", requestObj, mfdIndex);
						}
						skeys = pgEl.getElementsByClassName("softkey_right");
						if (skeys){
							currStr += WriteButtons(skeys, "R", requestObj, mfdIndex);
						}
						skeys = pgEl.getElementsByClassName("softkey_bottom");
						if (skeys){
							currStr += WriteButtons(skeys, "B", requestObj, mfdIndex);
						}
						if (currStr !== lastString){
							lastString = currStr;
							let relxhttp = new XMLHttpRequest();
							let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
							relxhttp.open("POST", relurl);
							relxhttp.send(JSON.stringify(requestObj));
						}
					}
				}
			}
		}
	};
	
	function WriteButtons(skeys, suffix, requestObj, mfdIndex){
		let retStr = "";
		for (let i = 1; i <= 6; i++){
			let evt = suffix + (i).toString();
			let fnd = false;
			let sval = "";
			let enval = 0;
			for (let j = 0; j <  skeys.length; j++){
				if (skeys[j].getAttribute("event") === evt){
					sval = skeys[j].innerText;
					let stat = skeys[j].getAttribute("state");
					let stat2 = skeys[j].getAttribute("state2");
					if (!stat && !stat2){
						enval = 1;
					} else {								
						if (stat && stat !== "inactive"){
							enval = 1;
						} else{
							if (stat2 && stat2 !== "inactive"){
								enval = 1;
							}
						}
					}
					break;
				}			
			}
            if (evt === "") enval = 0;
			retStr += "_" + evt + sval + enval.toString();
			let toset = { "var": "(L:HPG_MFD_" + (mfdIndex).toString() + "_SOFTKEY_"+ evt + ", String)", "value": sval };
			requestObj.setstringvars.push(toset);
			toset = { "var": "(L:HPG_MFD_" + (mfdIndex).toString() + "_SOFTKEY_"+ evt + "_ACTIVE)", "value": enval };
			requestObj.setvars.push(toset);
		}
		return retStr;
	};

	this.startup = function () {
		dloop = setInterval(DataLoop, 150);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaomfdmodule = new AaoMfdLink();
aaomfdmodule.startup();
